#!/home/perl/bin/perl
  
  #use strict;
  
  #use SOAP::Lite +trace => all;
  use SOAP::Lite;
  
  use Digest::MD5 'md5_hex';
  use URI;
  use HTTP::Cookies;

  die "USAGE: $0 method [arguement]\n" unless ( scalar @ARGV >= 1 );
  my @args = @ARGV;
  my $method = splice @args, 0, 1;
    
  # end point
  my $endpoint = 'http://127.0.0.1:8080';
  my $uri = new URI($endpoint);
    
  # create a user/passwd cookie
  my $cookie = make_cookie( "user", "password" );
  
  my $cookie_jar = HTTP::Cookies->new();
  $cookie_jar->set_cookie(0, user => $cookie, '/', $uri->host(), $uri->port());


  # create SOAP connection
  my $soap = new SOAP::Lite();
  
  $soap->uri('urn:/demo'); 
  $soap->proxy($endpoint, cookie_jar => $cookie_jar);
    
  # report
  print "Calling         : $method( @args )\n";
    
  # grab result 
  my $result;
  eval { $result = $soap->$method( @args ); };
  if ( $@ ) {
     print "Error: $@";
     exit;   
  }
  
  # Check for errors
  print "Transport Status: " . $soap->transport()->status() . "\n";
  
  unless ($result->fault() ) {
    print "SOAP Result     : " . $result->result() . "\n";
  } else {
    print "Fault Code      : " . $result->faultcode() ."\n";
    print "Fault String    : " . $result->faultstring() ."\n";
  }  
  
  exit;

# A S S O C I A T E D   S U B - R O U T I N E S ------------------------------

  # This is the code that is used to generate cookies based on the user
  # name and password. It is NOT cryptographically sound, it is just a
  # sim ple form of obfuscation, used as an example. Should be replaced
  # before system goes live. 
  sub make_cookie {
     my ($user, $passwd) = @_;
     my $cookie = $user . "::" . md5_hex($passwd);
     $cookie =~ s/(.)/sprintf("%%%02x", ord($1))/ge;
     $cookie =~ s/%/%25/g;
     return $cookie;
  }
